﻿/*
InterruptDemo for GTween by Grant Skinner, gskinner.com/blog/

This example demonstrates three concepts:
1) Dynamically creating tweens.
2) Reusing tweens.
3) Interrupting tweens.

Test movie, then click around the stage quickly. Note that you can interrupt
the tween while it is running, and it will attempt to recover appropriately.
*/

package  {
		
	import com.gskinner.motion.GTween;
	import com.gskinner.motion.easing.*;
	
	import flash.events.MouseEvent;
	import flash.display.MovieClip;
	import flash.display.Shape;
	
	public class GTweenInterrupt extends MovieClip {
		
	// Constants:
		
	// Public Properties:
		
	// Protected Properties:
		protected var tweens:Array = [];
		
	// Initialization:
		public function GTweenInterrupt() {
			// draw a bunch of circles, and set up tweens for them:
			for (var i:int=0; i<25; i++) {
				// draw the circle, and put it on stage:
				var circle:Shape = new Shape();
				circle.graphics.lineStyle(15,0x113355,1-i*0.02);
				circle.graphics.drawCircle(0,0,(i+1)*4);
				circle.x = Math.random()*550;
				circle.y = Math.random()*400;
				circle.blendMode = "add";
				addChild(circle);
				
				// set up a tween for each circle (initially tweening to the center):
				var circleTween:GTween = new GTween(circle,0.5+i*0.04,{x:275,y:200},{ease:Bounce.easeOut});
				tweens.push(circleTween);
			}
			
			stage.addEventListener(MouseEvent.CLICK,handleClick);
		}
		
	// Public getter / setters:
		
	// Public Methods:
		
	// Protected Methods:
		protected function handleClick(evt:MouseEvent):void {
			// update each tween with the new end property values.
			// note that I didn't create a new tween object, but reused the existing one instead.
			for (var i:int=0; i<tweens.length; i++) {
				tweens[i].setValues({x:mouseX,y:mouseY});
			}
		}
	}
	
}